\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{tabularx}
\usepackage{array}
\usepackage{amsmath}
\usepackage{breqn}
\usepackage{tikz}
\usetikzlibrary{automata,positioning, arrows}
\usepackage{hyperref}
\usepackage{graphicx} 
\usepackage{float}
\usepackage[center]{caption}
\usepackage{multirow}
\usepackage{textcomp}
\usepackage{graphicx}
\begin{document}
	
\title{CS-445}
\author{Aakarsh Nair}
\date{November 2021}

\title{Programming Assignment - 2}
\maketitle


\subsection*{Description}

In this assignment we trained a spam classifier which classified spam vs ham emails based 
on the features of various email as defined by the UCI spambase. First we trained the classifier 
to compute the loglikelihood of each of the features in the training set and then compare them to the 
loglikelhoods features in the email in the test set. As a simplifying assumption we assumed that 
the features were independent. Finally we picked the email's class  to be the one which maximized
the likelihoods of the features given the email was in a given class of spam or not 
spam

\subsection*{Results}

Write a few sentences describing your results, and answer these questions: 

\begin{enumerate}
	\item Include the accuracy, precision, and recall on the test set, as well as a confusion matrix for the test set.
	
	After running the experiment a couple of times and handling issues with the logliklhood became unstable for 
	low probable events we achieved the following numbers from our classification: 
	
	\begin{enumerate}
		\item Accuracy : 0.795
		\item Recall: 0.94
		\item Precision: 0.67
	\end{enumerate}
	
	The confusion matrix is shown in \textbf{Table 1}
	
	\begin{table}[!ht]
		\centering
		\caption{Confusion Matrix}
		\label{sa}
		\renewcommand{\arraystretch}{3}
		\begin{tabular}{l|l|l|l|}
			
			\multicolumn{2}{c}{}&   \multicolumn{2}{c}{Predicted Classes}\\
			\multicolumn{2}{c}{}&\multicolumn{2}{c}{{\rotatebox[origin=c]{0}{Spam}
				} {\rotatebox[origin=c]{0}{Ham}
			}}\\
			\cline{2-4}
			\multirow{2}{*}{{\rotatebox[origin=c]{90}{Actual Classes}
			}} 
			& Spam &862 & 417 \\ \cline{2-4}
			& Ham  & 54 & 968\\ \cline{2-4}
		\end{tabular}
	\end{table}

	\item Do you think the attributes here are independent, as assumed by Naïve Bayes? 
	
	Running PCA on the email features one sees that most of the singular values of the test data 
	features are low, and have low explained variance ratio's, implying that few of the features are 
	highly explanatory and the others are possibly dependent on them.
	
	\item  Does Naïve Bayes do well on this problem in spite of the independence assumption?
	
	The Naive Bayes is currently  still needs improvement as  it lets through a fair number of Spam 
	emails by classifying them as Ham.  It does substantially better at keeping Ham emails marked 
	as Ham. Hence doing much better on the recall. However the overall accuracy can stand to improve.
	
	\item  Speculate on other reasons Naïve Bayes might do well or poorly on this problem.
	
	We are currently assuming that many of the features are independent but there might be feature correlations
	which we maybe not be accounting for. Moreover a few badly behaved features might throw off our 
	overall probability. Some weighting of feature importance could also be useful. 
	
\end{enumerate}

\end{document}
	